
!GRGemStonePlatform methodsFor: '*seaside-gemstone-REST-core' stamp: 'DaleHenrichs 08/24/2010 13:58'!
argumentNamesOf: aMethod

	^(aMethod argsAndTemps copyFrom: 1 to: aMethod numArgs) collect: [:each | each asString ]! !

!GRGemStonePlatform methodsFor: '*seaside-gemstone-REST-core' stamp: 'topa 04/07/2011 13:17'!
methodsWithHttpPragmaIn: aClass do: aSixArgumentBlock
	aClass selectorsDo: [ :selector |
		| httpMethodName method |
		httpMethodName := nil.
		method := aClass >> selector.
		method pragmas do: [ :pragma |
			(WARoute httpMethodNames includes: pragma keyword) ifTrue: [
				httpMethodName := pragma keyword greaseString ] ].
		httpMethodName isNil ifFalse: [
			| path consumes produces |
			path := method pragmas detect: [:pragma | pragma keyword == #Path: ] ifNone: [ nil ].
			consumes := self mimeTypeMatchesAt: #Consumes: in: method.
			produces := self mimeTypeMatchesAt: #Produces: in: method.
			aSixArgumentBlock valueWithArguments: (Array
				with: method
				with: selector
				with: httpMethodName
				with: (path isNil ifFalse: [ path argumentAt: 1 ] )
				with: produces
				with: consumes) ] ]
! !

!GRGemStonePlatform methodsFor: '*seaside-gemstone-REST-core' stamp: 'topa 04/07/2011 13:21'!
mimeTypeMatchesAt: aSymbol in: aMethod
	| matches |
	matches := aMethod pragmas
		select: [ :each | each keyword = aSymbol ]
		thenCollect: [ :each | WAMimeTypeMatch fromString: each arguments first ].
	^ matches isEmpty
		ifTrue: [ WAWildcardMimeTypeMatch new ]
		ifFalse: [ WACompositeMimeTypeMatch matches: matches  ]! !
